# Hellsmith WAD Editor Proposal

The proposed Hellsmith WAD editor will be integrated into future versions of
the GZDoom codebase, for those who don't want to use Windows or apply Linux-specific kludges in their workflow.  This proposal could be GZDoom's crown jewel for cross-platform high-quality map creation workflows.

## The Namesake

This proposed tool is named after the **Hellsmith**, a major demon from 
Eriance/Amuscaria's old SP/co-op campaign, Demon Eclipse.  Some players 
envisage the Hellsmith as one of Hell's great architects.

## Synopsis

To invoke Hellsmith, launch GZDoom with the `-hellsmith` or `-editor` command line switches.  Launching GZDoom without those magic command line switches will launch the game, not the proposed integrated Hellsmith editor.

## General Features

This editor will have an integrated ACS script compiler derived from ACC,
capable of outputting any bytecode format supported by GZDoom.

## The Archive Editor Interface

The archive editor's interface should be a WxWidgets-independent variant 
of SLADE 3.x's archive editor's interface, with additional features 
including an actor tester, a 3D model viewer, a save-capable reverb 
editor and archive-specific advanced properties window.  The archive editor
will include a material editor for making those pretty PBR materials for
players with capable enough graphics cards.

## The Map Editor Interface

The map editor's interface will have a similar interface to GZDoom Builder 
but with cross-platform interoperability in mind.  Additional views can be 
created in a similar method to Blender's subdivision interface, with 
2D and 3D views in separate areas.  3D views can be rendered using hardware or software.  An example of a multi-view 
setup is a big 2D view on the left, with a Carmack renderer view 
on the upper right and a hardware-accelerated 3D view on the lower right.  Some 
interface elements may overlap, including dialog boxes and dockable 
properties windows.

## Unique Features (Map Editor)

* NODES Viewer, with tree view on left-hand side of 2D view for BSP nodes
* BLOCKMAP Viewer
* Sound Propagation Viewer (**GZDB and Eureka have this feature, and so will Hellsmith**)
* Reject table builder (**useful for monster-rich and/or sector-rich maps**)
* Visplane Explorer (**good for making vanilla DOOM/Heretic/Hexen maps**)
* Visplane Overlay (**Carmack renderer only, ditto for vanilla mapping**)
* Rendering Statistics 
* GZDoom rendering system, complete with Carmack, SoftPoly and hardware renderers
* User interface is drawn using the same code as the HUD, menus and console
* Platform-independent file browser for archives, archive entries, images and maps
* ACS script and line special preview (**for previewing them switches!**)
* Playtesting your map invokes the GZDoom game code (**Quitting the game takes you back to Hellsmith when active**)
* Ambient sound preview
* Animated textures, skies and flats
* Nodebuilding process visualization (optional)

## Key Differences between Hellsmith and GZDB-Bugfix

* Cross-platform! (**No need for Windows and DirectX when using Hellsmith**)
* Hellsmith has 3D view areas in place of GZDB's visual mode
* Previews the map's ambient audio
* Previews ACS scripts and line specials
* Permits use of the Carmack renderer
* More accurate previews of the map (**GZDB's visual mode may differ cosmetically due to Direct3D quirks**)
* Visualizes the node-building process

## How Hellsmith builds REJECT tables

REJECT tables are built with a variant of GZDoom's BLOCKMAP-based line 
of sight algorithm, with modifications for making monster line-of-sight 
tables for vanilla DOOM and other ports that use a BSP-based LoS 
algorithm.
